9275ade5d7c437d65956bd5a9c61cdb6d3fdfc4b
[xfstests-dev.git] / 016
1 #! /bin/bash
2 # FS QA Test No. 016
3 #
4 # test end of log overwrite bug #796141
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2003 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24 # creator
25 owner=dxm@sgi.com
26
27 #
28 # pv 796141
29 #
30 # create a new FS, mostly fill the log. Then wrap the log back to the
31 # start bit by bit to force wiping of stale blocks near the end of the
32 # log. Check the block after the log ends to check for corruption
33 #
34 # assumptions :
35 #    - given we're only touching a single inode, the block after the
36 #      log which is in the middle ag should never be touched.
37 #      if it changes, we assume the log is writing over it
38 #
39
40 seq=`basename $0`
41 echo "QA output created by $seq"
42
43 here=`pwd`
44 tmp=/tmp/$$
45 status=1
46
47 trap "_cleanup; exit \$status" 0 1 2 3 15
48
49 _cleanup()
50 {
51     cd /
52     rm -f $tmp.*
53     echo "*** unmount"
54     umount $SCRATCH_MNT 2>/dev/null
55 }
56
57 _block_filter()
58 {
59     sed -e 's/[0-9][0-9]*\.\.[0-9][0-9]*/BLOCKRANGE/g'
60 }
61
62 _init()
63 {
64     echo "*** reset partition"
65     $here/src/devzero -b 2048 -n 50 -v 198 $SCRATCH_DEV
66     echo "*** mkfs"
67     force_opts="-dsize=50m -lsize=$log_size"
68     echo mkfs_xfs $force_opts $SCRATCH_DEV >>$seq.full
69     _scratch_mkfs_xfs $force_opts >$tmp.mkfs0 2>&1
70     [ $? -ne 0 ] && \
71         _notrun "Cannot mkfs for this test using MKFS_OPTIONS specified"
72     _filter_mkfs <$tmp.mkfs0 >/dev/null 2>$tmp.mkfs
73     . $tmp.mkfs
74     [ $logsunit -ne 0 ] && \
75         _notrun "Cannot run this test using log MKFS_OPTIONS specified"
76 }
77
78 _log_traffic()
79 {
80     count=$1
81     echo "*** generate log traffic"
82
83     out=$SCRATCH_MNT/$$.tmp
84
85     echo "   *** mount"
86     if ! _scratch_mount
87     then
88         echo "failed to mount $SCRATCH_DEV"
89         exit 1
90     fi
91
92     # having any quota enabled (acct/enfd) means extra log traffic - evil!
93     $here/src/feature -U $SCRATCH_DEV && \
94                 _notrun "UQuota are enabled, test needs controlled log traffic"
95     $here/src/feature -G $SCRATCH_DEV && \
96                 _notrun "GQuota are enabled, test needs controlled log traffic"
97     $here/src/feature -P $SCRATCH_DEV && \
98                 _notrun "PQuota are enabled, test needs controlled log traffic"
99
100     echo "   *** fiddle"
101     while [ $count -ge 0 ]
102     do
103         touch $out
104         sync
105         rm $out
106         sync
107         let "count = count - 1"
108     done
109
110     echo "   *** unmount"
111     if ! umount $SCRATCH_DEV
112     then
113         echo "failed to unmount $SCRATCH_DEV"
114         exit 1
115     fi
116 }
117
118 _log_size()
119 {
120     _scratch_xfs_logprint -tb | $AWK_PROG '
121         /log file: / || /log device: / { print $7}
122     '
123 }
124
125 _log_head()
126 {
127     _scratch_xfs_logprint -tb | $AWK_PROG '
128         /head:/ { print $5 }
129     '
130 }
131
132 # Get log stripe unit for v2 logs; if none specified,
133 # (or v1 log) just return "1" block
134
135 _log_sunit()
136 {
137     if [ ${lsunit:-0} -eq 0 ]; then
138         echo $dbsize
139     else
140         expr $lsunit \* $dbsize
141     fi
142 }
143
144 _after_log()
145 {
146     xfs_db -r $1 -c "sb" -c "print" | $AWK_PROG '
147         /logstart/  { logstart = $3 }
148         /logblocks/ { logblocks = $3 }
149         END {
150             print logstart + logblocks
151         }
152     '
153 }
154
155 _check_corrupt()
156 {
157     f="c6c6c6c6"
158     echo "*** check for corruption"
159     echo "expect $f..." >>$seq.full
160     xfs_db -r -c "fsblock $2" -c "print" $1 | head | tee -a $seq.full | \
161         grep -q -v "$f $f $f $f $f $f $f $f" && \
162             _fail "!!! block $2 corrupted!"
163 }
164
165 # get standard environment, filters and checks
166 . ./common.rc
167 . ./common.filter
168
169 # real QA test starts here
170 _supported_fs xfs
171 _supported_os Linux
172
173 rm -f $seq.full
174
175 # mkfs sizes
176 log_size=2097152
177 log_size_bb=`expr $log_size / 512`
178
179 _require_scratch
180 _init
181
182 block=`_after_log $SCRATCH_DEV`
183 echo "fsblock after log = $block"               >>$seq.full
184 _check_corrupt $SCRATCH_DEV $block
185
186 actual_log_size=`_log_size`
187 echo "log size = $actual_log_size BB"                      >>$seq.full
188 head=`_log_head`
189 echo "log position = $head"                     >>$seq.full
190 lsunit=`_log_sunit`
191 echo "log sunit = $lsunit"                      >>$seq.full
192
193 # sanity checks
194 [ $actual_log_size -eq $log_size_bb ] || \
195     _fail "!!! unexpected log size $size"
196 [ $head -eq 2 -o $head -eq $((lsunit/512)) ] || \
197     _fail "!!! unexpected initial log position $head vs. $((lsunit/512))"
198
199 # find how how many blocks per op for 100 ops
200 # ignore the fact that it will also include an unmount record etc...
201 # this should be small overall
202 echo "    lots of traffic for sampling" >>$seq.full
203 sample_size_ops=100
204 _log_traffic $sample_size_ops
205 head1=`_log_head`
206 num_blocks=`expr $head1 - $head`
207 blocks_per_op=`echo "scale=3; $num_blocks / $sample_size_ops" | bc`
208 echo "blocks_per_op = $blocks_per_op" >>$seq.full
209 num_expected_ops=`echo "$log_size_bb / $blocks_per_op" | bc`
210 echo "num_expected_ops = $num_expected_ops" >>$seq.full
211 num_expected_to_go=`echo "$num_expected_ops - $sample_size_ops" | bc`
212 echo "num_expected_to_go = $num_expected_to_go" >>$seq.full
213
214 echo "    lots more traffic" >>$seq.full
215 _log_traffic $num_expected_to_go
216 head=`_log_head`
217 echo "log position = $head"                     >>$seq.full
218
219 # e.g. 3891
220 near_end_min=`echo "0.95 * $log_size_bb" | bc | sed 's/\..*//'`
221 echo "near_end_min = $near_end_min" >>$seq.full
222
223 [ $head -gt $near_end_min -a $head -lt $log_size_bb ] || \
224     _fail "!!! unexpected near end log position $head"
225
226 for c in `seq 0 20`
227 do
228     echo "   little traffic"            >>$seq.full
229     _log_traffic 2
230     head=`_log_head`
231     echo "log position = $head"         >>$seq.full
232     _check_corrupt $SCRATCH_DEV $block
233 done
234
235 [ $head -lt 1000 ] || \
236     _fail "!!! unexpected wrapped log position $head"
237
238 # success, all done
239 status=0
240 exit